-----------------------------------
-- Setting up scope and libs
-----------------------------------

local AddonName = select(1, ...);
iTracking = LibStub("AceAddon-3.0"):NewAddon(AddonName, "AceEvent-3.0");

-----------------------------
-- Setting up the feed
-----------------------------

iTracking.Feed = LibStub("LibDataBroker-1.1"):NewDataObject(AddonName, {
	type = "data source",
	text = "",
});

function iTracking.Feed.OnClick(anchor, button)
	if( button == "RightButton" ) then
		_G.ToggleDropDownMenu(1, nil, _G.MiniMapTrackingDropDown, anchor, 0, 0);
	end
end

----------------------
-- Initializing
----------------------

function iTracking:OnInitialize()
	self:RegisterEvent("PLAYER_ALIVE", "TrackUpdate");
	self:RegisterEvent("MINIMAP_UPDATE_TRACKING", "TrackUpdate");
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "TrackUpdate");
	
	_G.MiniMapTracking:UnregisterAllEvents();
	_G.MiniMapTracking:Hide();
end

------------------------------------------
-- Update
------------------------------------------

function iTracking:TrackUpdate(num)
	if( not num or type(num) ~= "number" ) then num = 1 end
	
	local tracking = 0;
	
	for i = 1, _G.GetNumTrackingTypes() do
		local name, icon, active = _G.GetTrackingInfo(i);
		
		if( active ) then
			tracking = tracking + 1;
			
			if( tracking == 1 ) then
				self.Feed.text = name;
				self.Feed.icon = icon;
			end
		end
	end
	
	if( tracking == 0 ) then
		self.Feed.text = _G.FACTION_INACTIVE;
		self.Feed.icon = "Interface\\Minimap\\Tracking\\None";
	else
		self.Feed.text = ("|cff00ff00%d|r %s"):format(tracking, self.Feed.text);
	end
	
	if( num <= 10 ) then
		self:TrackUpdate(num +1);
	end
end